<?php
/**
 * @Description: 投票插件钩子实现
 * @author Microrain  xinjy@qq.com
 * @date 14-3-9
 * @version V0.1
 */
namespace Addons\OneVote;

use Common\Controller\Addon;

class OneVoteAddon extends Addon
{
	public function __construct()
	{
		parent::__construct();
		include_once $this->addon_path . 'function.php';
	}

	public $info = array(
		'name' => 'OneVote',
		'title' => '微投票',
		'description' => '支持单选、多选的小投票插件。可以用来收集用户对某几个选项的意见。',
		'status' => 1,
		'author' => 'Microrain',
		'version' => '1.0'
	);

	public $admin_list = array(
		'model' => 'onevote', //要查的表
		'fields' => '*', //要查的字段
		'map' => '', //查询条件, 如果需要可以再插件类的构造方法里动态重置这个属性
		'order' => 'id desc', //排序,
		'list_grid' => array( //这里定义的是除了id序号外的表格里字段显示的表头名和模型一样支持函数和链接
			'title:标题:[EDIT]',
			'description:说明',
			'voteconfig|viewtype:类型',
			'create_time|time_format:创建时间',
			'id:操作:[EDIT]|编辑,[DELETE]|删除'
		),
	);

	public function install()
	{
		$installresult = false;
		if(installDB($this->addon_path . 'onevote.sql',"onevote")){
			if(installHooks("OneVote","微投票插件的钩子")){
				$installresult = true;
			}
		}
		return $installresult;
//		$sql = file_get_contents($this->addon_path . 'onevote.sql');
//		$db_prefix = C('DB_PREFIX');
//		$sql = str_replace('onethink_', $db_prefix, $sql);
//
//		D()->execute($sql);
//		$table_name = $db_prefix.'onevote';
//		if(count(M()->query("SHOW TABLES LIKE '{$table_name}'")) != 1){
//			session('addons_install_error', ',onevote表未创建成功，请手动检查插件中的sql，修复后重新安装');
//			return false;
//		} else {
//			$model = M('hooks');
//			if ($model->where("name='OneVote' AND type=2")->find()) {
//				return true;
//			}
//			$model->name = 'OneVote';
//			$model->description = '微投票插件的钩子';
//			$model->update_time = time();
//			$model->type = 1;
//			if ($model->add()) {
//				return true;
//			} else {
//				return false;
//			}
//		}

	}

	public function uninstall()
	{
		$db_prefix = C('DB_PREFIX');
		$sql = "DROP TABLE IF EXISTS `{$db_prefix}onevote`;";
		D()->execute($sql);
		$model = M('hooks');
		if ($model->where("name='OneVote'")->delete()) {
			return true;
		} else {
			return false;
		}
	}

	/**
	 * @param $param
	 *在前台页面加入 {:hook('OneVote')}
	 */
	public function OneVote($param)
	{
		//获取插件的配置信息
		$config = $this->getConfig();
		if($config['defaultid']==0){
			$list = M('onevote')->order('id desc')->find();

		} else {
			$list = M('onevote')->where('id='.$config["defaultid"])->find();
		}

		$options = $list["options"];
		$options = json_decode($options, true);
		$this->assign("id",$list['id']);
		$this->assign("title", $list["title"]);
		$this->assign("voteconfig", $list['voteconfig']);
		$this->assign("options", $options);


		$this->assign('addons_config', $config);
		if($config['display'])
			$this->display('View/Default/viewvote');
	}

}